Makefile.am 9.69 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
Michael Hanselmann's avatar
Michael Hanselmann committed
14
BUILD_RAPI_RESOURCE_DOC = $(top_srcdir)/doc/build-rapi-resources-doc
15 16 17
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
18
httpdir = $(pkgpythondir)/http
19
rapidir = $(pkgpythondir)/rapi
20 21 22 23 24 25 26 27 28
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
Guido Trotter's avatar
Guido Trotter committed
29
	doc/examples/hooks \
30
	lib \
31
	lib/http \
32
	lib/hypervisor \
33
	lib/rapi \
34 35 36 37 38 39 40
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
41 42 43 44 45
MAINTAINERCLEANFILES = \
	$(dochtml) \
	$(patsubst %.dot,%.png,$(docdot)) \
	$(maninput)

46 47 48
CLEANFILES = \
	autotools/replace_vars.sed \
	devel/upload \
49
	doc/rapi-resources.gen \
50
	doc/examples/bash_completion \
51 52 53
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
54
	lib/http/*.py[co] \
55
	lib/hypervisor/*.py[co] \
56
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
57 58
	$(man_MANS) \
	$(manhtml) \
59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
76
	lib/daemon.py \
77 78
	lib/errors.py \
	lib/jqueue.py \
79
	lib/jstore.py \
80 81 82 83 84 85 86 87 88
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
89 90
	lib/utils.py \
	lib/workerpool.py
91 92 93 94 95

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
96
	lib/hypervisor/hv_kvm.py \
97 98
	lib/hypervisor/hv_xen.py

99 100
rapi_PYTHON = \
	lib/rapi/__init__.py \
101 102 103
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
104

105
http_PYTHON = \
106
	lib/http/__init__.py \
107
	lib/http/auth.py \
108 109
	lib/http/client.py \
	lib/http/server.py
110

111

Michael Hanselmann's avatar
Michael Hanselmann committed
112
docrst = \
113
	doc/admin.rst \
114
	doc/design-2.0.rst \
115
	doc/hooks.rst \
116
	doc/iallocator.rst \
117
	doc/install.rst \
118
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
119

Iustin Pop's avatar
Iustin Pop committed
120 121
dochtml = $(patsubst %.rst,%.html,$(docrst))

122 123 124
docdot = \
	doc/arch-2.0.dot

Iustin Pop's avatar
Iustin Pop committed
125
doc_DATA = $(dochtml)
126

127 128
noinst_DATA = $(manhtml)

129 130 131 132
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
133
	daemons/ganeti-rapi \
134 135 136 137 138 139 140 141 142 143 144 145 146 147 148
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
149
	$(MAINTAINERCLEANFILES) \
150 151
	NEWS \
	DEVNOTES \
Michael Hanselmann's avatar
Michael Hanselmann committed
152
	pylintrc \
153 154
	autotools/docbook-wrapper \
	devel/upload.in \
Michael Hanselmann's avatar
Michael Hanselmann committed
155
	$(docrst) \
156
	$(docdot) \
157
	doc/build-rapi-resources-doc \
158
	doc/examples/bash_completion.in \
159 160 161
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
Guido Trotter's avatar
Guido Trotter committed
162
	doc/examples/hooks/ethers \
163
	doc/locking.txt \
164 165 166 167 168
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
169
	$(mansgml) $(maninput) \
170
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
171
	qa/qa-sample.json \
172 173 174 175 176 177 178 179
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
180
	qa/qa_rapi.py \
181 182 183 184 185
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
186
	man/ganeti-masterd.8 \
187 188
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
189
	man/ganeti-rapi.8 \
190 191 192
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
193
	man/gnt-debug.8 \
194
	man/gnt-instance.8 \
195
	man/gnt-job.8 \
196 197 198
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
199 200 201
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
202 203 204

TEST_FILES = \
	test/data/bdev-both.txt \
205
	test/data/bdev-8.3-both.txt \
206 207
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
208 209
	test/data/proc_drbd8.txt \
	test/data/proc_drbd83.txt
210 211

dist_TESTS = \
212 213 214
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
215
	test/ganeti.config_unittest.py \
216
	test/ganeti.constants_unittest.py \
217
	test/ganeti.hooks_unittest.py \
218
	test/ganeti.http_unittest.py \
219
	test/ganeti.locking_unittest.py \
220
	test/ganeti.rapi.resources_unittest.py \
221 222 223 224
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
225 226 227 228 229

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

230
TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir) $(PYTHON)
231

232
RAPI_RESOURCES = $(wildcard lib/rapi/*.py)
233

234
all-local: stamp-directories lib/_autoconf.py devel/upload \
Iustin Pop's avatar
Iustin Pop committed
235
	doc/examples/bash_completion \
236 237 238 239 240 241
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
242
doc/examples/%: doc/examples/%.in stamp-directories \
243 244 245
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

Michael Hanselmann's avatar
Michael Hanselmann committed
246
doc/%.html: doc/%.rst
Iustin Pop's avatar
Iustin Pop committed
247
	@test -n "$(RST2HTML)" || { echo 'rst2html' not found during configure; exit 1; }
Michael Hanselmann's avatar
Michael Hanselmann committed
248 249
	$(RST2HTML) $< $@

250
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
251
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
252 253 254 255
	$(DOT) -Tpng -o $@ $<

doc/design-2.0.html: doc/design-2.0.rst doc/arch-2.0.png

Iustin Pop's avatar
Iustin Pop committed
256
doc/rapi.html: doc/rapi-resources.gen
257

258 259 260
doc/rapi-resources.gen: $(BUILD_RAPI_RESOURCE_DOC) $(RAPI_RESOURCES)
	PYTHONPATH=.:$(top_builddir) $(BUILD_RAPI_RESOURCE_DOC) > $@ || \
	  rm -f $@
261

Iustin Pop's avatar
Iustin Pop committed
262
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
263
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
264 265 266 267 268 269 270
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
271
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
272 273 274 275 276 277 278 279
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
280

Iustin Pop's avatar
Iustin Pop committed
281 282
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
283

Iustin Pop's avatar
Iustin Pop committed
284 285
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
286

287 288
man/footer.sgml $(TESTS): srclinks

Michael Hanselmann's avatar
Michael Hanselmann committed
289
$(TESTS) $(BUILD_RAPI_RESOURCE_DOC): ganeti lib/_autoconf.py
290 291 292 293 294

lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
295 296 297 298 299 300 301 302 303
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
304 305 306 307 308 309 310 311 312 313 314 315 316 317 318
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
319
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
320
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
321
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
322
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)" ; \
323 324 325 326 327 328 329 330 331 332 333
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
334
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
Iustin Pop's avatar
Iustin Pop committed
335
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
336 337 338 339 340 341 342
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
#.PHONY: srclinks
srclinks: stamp-directories
	set -e; \
343 344
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
			$(rapi_PYTHON) $(http_PYTHON); do \
345 346 347 348
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
349

Michael Hanselmann's avatar
Michael Hanselmann committed
350 351
.PHONY: ganeti
ganeti:
352
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
353

Iustin Pop's avatar
Iustin Pop committed
354 355 356 357 358 359 360
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
361
install-exec-local:
362
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
363 364
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
365 366 367 368 369

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
370 371 372
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
373
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
374 375
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
376
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
377 378
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
379
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
380 381 382 383
		) ; \
		rm -rf $$TMPDIR ; \
	}

384
# vim: set noet :